/**
 *SSO App
 * Defined UNAS 3.0 SSO manager
 */
var BDRApp = BDRApp || {}; //Define App namespace, if you want.
/**
 *Constructor UNAS App
 */
BDRApp.App = function() {
  this.id = 'BDRClient';
  this.name = 'BDR Client';
  this.version = '6.0.0';
  this.active = false;
  this.menuIcon = '/apps/bdrclient/images/logo.png?v=6.0.0&';
  this.shortcutIcon = '/apps/bdrclient/images/logo.png?v=6.0.0&';
  this.entryUrl = '/apps/bdrclient/bdr.html?v=6.0.0&';
  //this.entryHelpUrl = '/apps/sso/sso_help.html';
  var self = this;
  this.BDRAppWindow = function() { //create app window
    if (UNAS.CheckAppState('BDR Client')) {
      return false;
    }
    self.window = new MUI.Window({
      id: 'BDRAppWindow',
      title: UNAS._('BDR Client'),
      icon: '/apps/bdrclient/images/logo_small.png?v=6.0.0&',
      loadMethod: 'xhr',
      width: 886,
      height: 540,
      maximizable: false,
      resizable: true,
      scrollbars: false,
      contentURL: '/apps/bdrclient/bdr.html?v=6.0.0&',
      require: {
        css: ['/apps/bdrclient/css/bdr.css?v=6.0.0']
      },
      onBeforeBuild: function() {
        UNAS.SetAppOpenedWindow("BDR Client", 'BDRAppWindow');
      }
    });
  };
  this.BDRUninstall = function() {
    UNAS.RemoveDesktopShortcut('BDR Client');
    UNAS.RemoveMenu('BDR Client');
    UNAS.RemoveAppFromGroups('BDR Client', 'ControlPanel');
    UNAS.RemoveAppFromGroups('BDR Client', 'Help');
    UNAS.RemoveAppFromApps('BDR Client');
  };
  new UNAS.Menu('UNAS_ControlPanel_Network_Menu',
  this.name, this.menuIcon, 'BDR Client', '', this.BDRAppWindow);
  new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', {
    'Type': 'Network',
    'Location': 4,
    "Icon": this.shortcutIcon,
    "Url": this.entryUrl
  }, {});
  var OnChangeLanguage = function(e) {
    UNAS.SetMenuTitle('BDR Client', UNAS._('BDR Client')); //translate menu
    //UNAS.SetShortcutTitle('SSO', UNAS._('User Account'));
    if (typeof self.window !== 'undefined') {
      UNAS.SetWindowTitle('BDRAppWindow', UNAS._('BDR Client'));
    }
  };
  UNAS.LoadTranslation('/apps/bdrclient/languages/Translation?v=' + this.version, OnChangeLanguage);
  UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
  UNAS.CreateApp(this.name, this.shortcutIcon, this.BDRAppWindow, this.BDRUninstall);
};

new BDRApp.App();
