function bdrclient_settingload() {
  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'bdrclient_settingload'
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      if (res.err == 0) {
        var info = res.results || {};
        var nebula = info.nebula || {};
        var report = info.report || {};
        jQuery('#jv-ebs').prop('checked', info.active);
        jQuery('#jv-report').val(report.interval || 60);
        jQuery('#jv-cloudurl').val(nebula.url || '');
        jQuery('#jv-uid-bdr').val(nebula.uid || '');
        jQuery('#jv-pwd-bdr').val(nebula.pwd || '');
        jQuery('#jv-backup-bdr').val(nebula.interval || 5);
        if (info.inbackup) {
          jQuery('#jv-lastbackuptime').html('Backing up...');
        } else {
          jQuery('#jv-lastbackuptime').html(info.backuptime || '--');
        }
        bdrTranslator('jv-lastbackuptime');
      }
    },
    complete: function(xml) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

function bdrclient_settingsave() {
  var active = jQuery('#jv-ebs').prop('checked') ? 1 : 0;
  var interval = +jQuery('#jv-report').val();
  var url = jQuery('#jv-cloudurl').val();
  var uid = jQuery('#jv-uid-bdr').val();
  var pwd = jQuery('#jv-pwd-bdr').val();
  var backup_interval = +jQuery('#jv-backup-bdr').val();
  var dmpaths = [];
  var dataset = jQuery('#jv-poolhost input[name=dataset]:checked');
  dataset.each(function(i, e) {
    dmpaths.push(jQuery(e).val());
  })

  jQuery('#jv-bdrpageloading').show();

  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.encode({
      "token": UToken,
      "cmd": 'bdrclient_settingsave',
      params: {
        active: active,
        report: {
          interval: interval
        },
        nebula: {
          url: url,
          uid: uid,
          pwd: pwd,
          interval: backup_interval
        },
        dmpaths: dmpaths
      }
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      if (res.err == 0) {
        bdrclient_settingload();
      }
    },
    complete: function(xml) {
      jQuery('#jv-bdrpageloading').hide();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

function bdrclient_zfstorage() {
  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'bdrclient_zfstorage'
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      var info = res.results || {};
      var i = 0
      jQuery('#jv-poolhost').empty();
      for (var v in info) {
        if (info.hasOwnProperty(v)) {
          var tp_ = info[v];
          var pooldom = bdrTemplateAppend('#jv-poolhost', 'jvt-pooldatasetitem', 'jvt-pooldatasetitem-' + i);
          pooldom.find('.poolname').text(v || '--');
          pooldom.find('input[name=pool]').on('click', function() {
            var len = jQuery('#jv-poolhost input[name=pool]').length;
            var len_ck = jQuery('#jv-poolhost input[name=pool]:checked').length;
            if (len == len_ck) {
              jQuery('#jv-pdallchk').prop('checked', true);
            } else {
              jQuery('#jv-pdallchk').prop('checked', false);
            }
            var pnode = jQuery(this).closest('div.pool-datase-titem');
            if (jQuery(this).prop('checked')) {
              pnode.find('.datasetlist input').prop('checked', true);
            } else {
              pnode.find('.datasetlist input').prop('checked', false);
            }
          })

          var j = 0;
          for (var k in tp_) {
            if (tp_.hasOwnProperty(k)) {
              var td_ = tp_[k];
              var ddom = bdrTemplateAppend(pooldom.find('.datasetlist'), 'jvt-datasetitem', 'jvt-datasetitem-' + i + j)
              ddom.attr('style', "justify-content: space-between");
              ddom.find('.datasetname').text(k || '--');

              ddom.find('input[name=dataset]').val(td_.dmpath).on('click', function() {
                var pnode = jQuery(this).closest('div.pool-datase-titem');

                var d_len = pnode.find('input[name=dataset]').length;
                var d_len_ck = pnode.find('input[name=dataset]:checked').length;
                if (d_len == d_len_ck) {
                  pnode.find('input[name=pool]').prop('checked', true);
                } else {
                  pnode.find('input[name=pool]').prop('checked', false);
                }
                var p_len = jQuery('#jv-poolhost input[name=pool]').length;
                var p_len_ck = jQuery('#jv-poolhost input[name=pool]:checked').length;

                if (p_len == p_len_ck) {
                  jQuery('#jv-pdallchk').prop('checked', true);
                } else {
                  jQuery('#jv-pdallchk').prop('checked', false);
                }

              })

              ddom.find('.backup-details').data('d_info', td_).on('click', function() {
                var d_info = jQuery(this).data('d_info');
                backupdetails_dbr(d_info);
              })
            }
            j++;
          }
        }
        i++;
      }

    },
    complete: function(xml) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}


function upbdrapplybtn() {
  var report = +jQuery('#jv-report').val() || 0;
  var backuptime = +jQuery('#jv-backup-bdr').val() || 0;

  var url = jQuery('#jv-cloudurl').val();

  if (report && report >= 60) {
    jQuery('#jv-bdrapplybtn').attr('class', 'unas_button');
    if (url) {
      if (backuptime >= 5) {
        jQuery('#jv-bdrapplybtn').attr('class', 'unas_button');
      } else {
        jQuery('#jv-bdrapplybtn').attr('class', 'unas_button_disabled');
      }
    }
  } else {
    jQuery('#jv-bdrapplybtn').attr('class', 'unas_button_disabled');
  }
}

(function() {
  bdrclient_settingload();
  bdrclient_zfstorage();
  jQuery('#jv-pdallchk').on('click', function() {
    var allpool = jQuery('#jv-poolhost input[type="checkbox"]');
    if (this.checked) {
      allpool.prop('checked', true);
    } else {
      allpool.prop('checked', false);
    }
  })

  jQuery("#jv-poollist").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });

  jQuery('#jv-report').bind('input propertychange', function(e) {
    var v = +jQuery(this).val() || 0;
    if (v < 60) {
      jQuery(this).attr('class', 'unas_input_error');
    } else {
      jQuery(this).attr('class', 'unas_input');
    }
    upbdrapplybtn();
  });

  jQuery('#jv-backup-bdr').bind('input propertychange', function(e) {
    var v = +jQuery(this).val() || 0;
    if (v < 5) {
      jQuery(this).attr('class', 'unas_input_error');
    } else {
      jQuery(this).attr('class', 'unas_input');
    }
    upbdrapplybtn();
  });

  jQuery('#jv-cloudurl').bind('input propertychange', function(e) {
    upbdrapplybtn();
  });

})();
